OpenTTD Source: src/genworld.cpp File Reference

OpenTTD Source 12.0-beta1

Data Structures | Functions | Variables
genworld.cpp File Reference
`#include "stdafx.h"`
`#include "landscape.h"`
`#include "company_func.h"`
`#include "genworld.h"`
`#include "gfxinit.h"`
`#include "window_func.h"`
`#include "network/network.h"`
`#include "heightmap.h"`
`#include "viewport_func.h"`
`#include "date_func.h"`
`#include "engine_func.h"`
`#include "water.h"`
`#include "video/video_driver.hpp"`
`#include "tilehighlight_func.h"`
`#include "saveload/saveload.h"`
`#include "void_map.h"`
`#include "town.h"`
`#include "newgrf.h"`
`#include "core/random_func.hpp"`
`#include "core/backup_type.hpp"`
`#include "progress.h"`
`#include "error.h"`
`#include "game/game.hpp"`
`#include "game/game_instance.hpp"`
`#include "string_func.h"`
`#include "thread.h"`
`#include "tgp.h"`
`#include "safeguards.h"`

Go to the source code of this file.

## Data Structures
class | AbortGenerateWorldSignal

## Functions
void | GenerateClearTile ()
void | GenerateIndustries ()
| This function will create random industries during game creation. More...
void | GenerateObjects ()
void | GenerateTrees ()
| Place new trees. More...
void | StartupEconomy ()
void | StartupCompanies ()
| Start the next competitor now.
void | StartupDisasters ()
void | InitializeGame (uint size_x, uint size_y, bool reset_date, bool reset_settings)
static void | CleanupGeneration ()
| Generation is done; show windows again and delete the progress window.
static void | _GenerateWorld ()
| The internal, real, generate function.
void | GenerateWorldSetCallback (GWDoneProc *proc)
| Set here the function, if any, that you want to be called when landscape generation is done. More...
void | GenerateWorldSetAbortCallback (GWAbortProc *proc)
| Set here the function, if any, that you want to be called when landscape generation is aborted. More...
void | AbortGeneratingWorld ()
| Initializes the abortion process.
bool | IsGeneratingWorldAborted ()
| Is the generation being aborted? More...
void | HandleGeneratingWorldAbortion ()
| Really handle the abortion, i.e. More...
void | GenerateWorld (GenWorldMode mode, uint size_x, uint size_y, bool reset_settings)
| Generate a world. More...

## Variables
GenWorldInfo | _gw
| Please only use this variable in genworld.h and genworld.cpp and nowhere else. More...
bool | _generating_world
| Whether we are generating the map or not.

## Detailed Description

Functions to generate a map.

Definition in file genworld.cpp.

## Function Documentation

## ◆ GenerateIndustries()

void GenerateIndustries | ( |  | ) |

This function will create random industries during game creation.

It will scale the amount of industries by mapsize and difficulty level.

Definition at line 2303 of file industry_cmd.cpp.

## ◆ GenerateTrees()

void GenerateTrees | ( |  | ) |

Place new trees.

This function takes care of the selected tree placer algorithm and place randomly the trees for a new game.

Definition at line 346 of file tree_cmd.cpp.

References _settings_game, GameSettings::game_creation, GameCreationSettings::landscape, TP_NONE, TP_ORIGINAL, and GameCreationSettings::tree_placer.

## ◆ GenerateWorld()

void GenerateWorld | ( | GenWorldMode | mode,
|  | uint | size_x,
|  | uint | size_y,
|  | bool | reset_settings
| ) |  |

Generate a world.

Parameters

  mode | The mode of world generation (see GenWorldMode).
  size_x | The X-size of the map.
  size_y | The Y-size of the map.
  reset_settings | Whether to reset the game configuration (used for restart)

Definition at line 272 of file genworld.cpp.

References _gw, _local_company, GenWorldInfo::abort, GenWorldInfo::abortp, COMPANY_SPECTATOR, HasModalProgress(), GenWorldInfo::lc, GenWorldInfo::mode, SetLocalCompany(), SetModalProgress(), GenWorldInfo::size_x, and GenWorldInfo::size_y.

## ◆ GenerateWorldSetAbortCallback()

void GenerateWorldSetAbortCallback | ( | GWAbortProc * | proc | ) |

Set here the function, if any, that you want to be called when landscape generation is aborted.

Parameters

  proc | callback procedure

Definition at line 230 of file genworld.cpp.

References _gw, and GenWorldInfo::abortp.

Referenced by GenerateTerrainPerlin().

## ◆ GenerateWorldSetCallback()

void GenerateWorldSetCallback | ( | GWDoneProc * | proc | ) |

Set here the function, if any, that you want to be called when landscape generation is done.

Parameters

  proc | callback procedure

Definition at line 220 of file genworld.cpp.

References _gw, and GenWorldInfo::proc.

## ◆ HandleGeneratingWorldAbortion()

void HandleGeneratingWorldAbortion | ( |  | ) |

Really handle the abortion, i.e.

clean up some of the mess

Definition at line 255 of file genworld.cpp.

References _switch_mode.

## ◆ IsGeneratingWorldAborted()

bool IsGeneratingWorldAborted | ( |  | ) |

Is the generation being aborted?

Returns
  the 'aborted' status

Definition at line 247 of file genworld.cpp.

References _gw, and GenWorldInfo::abort.

## Variable Documentation

## ◆ _gw

GenWorldInfo _gw

Please only use this variable in genworld.h and genworld.cpp and nowhere else.

For speed improvements we need it to be global, but in no way the meaning of it is to use it anywhere else besides in the genworld.h and genworld.cpp!

Definition at line 58 of file genworld.cpp.

Referenced by AbortGeneratingWorld(), GenerateWorld(), GenerateWorldSetAbortCallback(), GenerateWorldSetCallback(), and IsGeneratingWorldAborted().